<?php
/**
* @desc This contains common functions for the API
*/

function ReadVars() {
    global $action,$argv,$argc;
    $stdin_stream = fopen('php://stdin', 'r');
    if (strpos(@$argv[1],"=")!==FALSE) {
        // If we've passed in a command line, push it into the $_GET section
        // this means we can support name=value pairs as command line options
        if ($argc > 0) {
            for ($i=1;$i < $argc;$i++) {
                parse_str($argv[$i],$tmp);        
                $_GET = array_merge($_GET, array_map('urldecode', $tmp));
            }
        }
    } elseif ( is_resource($stdin_stream) ) {
        if ( $line = fgets($stdin_stream, 1024) ) {
            parse_str(trim($line),$tmp);
            $_GET = array_merge($_GET, array_map('urldecode', $tmp));
        }
    }
    if (isset($_GET['action'])) { $action = $_GET['action']; }       
}

function AccessControl($password_for_this_script) {
    
    if (!empty($_SERVER['DOCUMENT_ROOT']) && empty($password_for_this_script)) {
        echo "This script should be started from the command line only.<br>Terminating.\n";
        exit();
    } 
	
    if ($password_for_this_script == "") {
        echo "Edit config.php and provide a password first!";
        exit();    
    }
    if (!isset($_GET['api_password'])) {
        echo "Please include api_password=[password] in the URI of any api based requests\n";
        exit();
    } else if ($_GET['api_password']!=$password_for_this_script) {
        echo "Access Denied";
        exit();    
    }
    return;    
}

function getProfileList($username) {
    global $db;
    
    $query = @$db->Execute("select profiles from `_logaholic_users` where username=\"$username\"") or die("An error occurred:" .$db->ErrorMsg());
    if ($query->NumRows()==0) {
        echo ("An error occurred: User $username not found");    
        return false;
    }        
    $q = $query->FetchRow();
    return $q['profiles'];    
}

function saveProfileList($username,$profile_list) {
    global $db;
    
    $q = "UPDATE _logaholic_users SET profiles=\"$profile_list\" WHERE username=\"$username\"";
    @$db->Execute($q) or die ("An error occurred: ".$db->ErrorMsg());    
}

/**
* @desc This function returns the users that have access to a given profile
*/    
function GetUsersForProfile($profilename) {
    global $db;
    $users = array();
    $q = $db->Execute("select username from _logaholic_users where (profiles='$profilename' or profiles like '$profilename,%' or profiles like '%,$profilename,%' or profiles like '%,$profilename')");
    while ($data = $q->FetchRow()) {
        if ($data['username']) {
            $users[]=$data['username'];
        } 
    }
    return implode(",",$users);    
}

/**
* @desc This function deletes the profile from all users
*/
function DeleteProfileFromUsers($profilename) {        
    $users = explode(",",GetUsersForProfile($profilename));
    foreach ($users as $user) {
        
		$plist = getProfileList($user);
        $plist_arr = explode(',', $plist);
        $plist_arr_keep = array();
        foreach ($plist_arr as $site) {
            $site = trim($site);
            if ($site && $site != $profilename) {
                $plist_arr_keep[] = $site;
            }
        }
        $plist = (count($plist_arr_keep)) ? implode(',', $plist_arr_keep) : '';
        saveProfileList($user,$plist);
    }    
}

function affiliateID() {
	if (setGlobalSetting("affiliate_id",$_GET['affiliateid'])) {
		die("Error");
	} else {
		echo "Success: Set affiliateid to ".$_GET['affiliateid'];
		return true;	
	}
}
?>
